import random
import string

'''
Generujemy "akceptowalne" haslo zawierajace mala litere, wielka litere,
znak interpunkcyjny i cyfre, generujac losowe napisy az do uzyskania hasla.
Zwracamy tez liczbe podjetych prob.
'''


def acceptable_password(password):
    def contains_character(from_str):
        for c in password:
            if c in from_str:
                return True
        return False

    if len(password) < 4:
        return False

    if not contains_character(string.ascii_uppercase): return False
    if not contains_character(string.ascii_lowercase): return False
    if not contains_character(string.digits): return False
    if not contains_character(string.punctuation): return False
    return True


def generate_string(n):
    all_characters = string.ascii_uppercase + string.ascii_lowercase + \
                     string.digits + string.punctuation
    return ''.join([random.choice(all_characters) for _ in range(n)])


def generate_password(n):
    tries = 0
    while True:
        tries += 1
        password = generate_string(n)
        if acceptable_password(password):
            return password, tries


if __name__ == "__main__":
    print(generate_password(7))
