import random


def die_roll():
    return random.randint(1, 6)


def coin_toss():
    return random.choice(['Heads', 'Tails'])


def loaded_coin_toss(prob):
    if random.random() < prob:
        return 'Heads'
    return 'Tails'


def test_dice(num_rolls):
    assert num_rolls > 0
    rolls = [0] * 7

    for _ in range(num_rolls):
        roll = die_roll()
        rolls[roll] += 1

    print(f'Rolling dice:\nOut of {num_rolls} rolls:'.format(num_rolls))
    for i in range(1, 7):
        print(f'{i} rolled {rolls[i]} times ({rolls[i] * 100 / num_rolls}%)')


def test_coins(num_tosses):
    assert num_tosses > 0
    heads, tails = 0, 0

    for _ in range(num_tosses):
        if coin_toss() == 'Heads':
            heads += 1
        else:
            tails += 1
    print(f'Tossing coins:\nOut of {num_tosses} tosses:')
    print(f'{heads} were heads ({heads * 100 / num_tosses}%)')
    print(f'{tails} were tails ({tails *100 / num_tosses}%)')


if __name__ == "__main__":
    test_dice(1000)
    test_coins(1000)
    

